#include<iostream>
#include<vector>
#include<queue>
using namespace std;
const int MAX_N=3e5+4;

int level[MAX_N];
int cnt1[MAX_N];
int cnt2[MAX_N];
int entire[MAX_N];
int ans;
int all1;
int all2;

vector<int>g[MAX_N];
bool ok[MAX_N];
int n,m;

int used[MAX_N];
int cnt;
vector<int>comp[MAX_N];
int sz[MAX_N];
void Read()
{
    cin>>n;
    for(int i=1;i<=n;i++)
    {
        cin>>ok[i];
    }
    cin>>m;
    int u,v;
    for(int i=1;i<=m;i++)
    {
        cin>>u>>v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
}
void DFS(int u)
{
    if(ok[u])comp[cnt].push_back(u);
    used[u]=cnt;
    sz[cnt]++;
    for(int v:g[u])
    {
        if(!used[v])
        {
            DFS(v);
        }
    }
}
void Comps()
{
    for(int i=1;i<=n;i++)
    {
        if(!used[i])
        {
            cnt++;
            DFS(i);
        }
    }
}
void SolveFor(int cur)
{
    queue<int>q;
    for(int u:comp[cur])
    {
        level[u]=1;
        cnt1[cur]++;
        q.push(u);
    }
    if(comp[cur].size()>=2){entire[cur]=1;return;}
    while(!q.empty())
    {
        int u=q.front();
        q.pop();
        for(int v:g[u])
        {
            if(!level[v])
            {
                level[v]=level[u]+1;
                if(level[v]%2==0)cnt2[cur]++;
                else cnt1[cur]++;
                q.push(v);
            }

        }
    }
}
void Solve()
{
    for(int i=1;i<=cnt;i++)
    {
        SolveFor(i);
        if(entire[i])ans+=sz[i];
        else
        {
            all1+=cnt1[i];
            all2+=cnt2[i];
        }
    }
    cout<<ans+max(all1,all2)<<endl;
}
void Check()
{
    for(int i=1;i<=cnt;i++)
    {
        for(int v:comp[i])
        {
            cout<<v<<" ";
        }
        cout<<endl;
    }
    cout<<endl;
    for(int i=1;i<=n;i++)
    {
        cout<<used[i]<<" ";
    }
    cout<<endl;
    for(int i=1;i<=n;i++)
    {
        cout<<level[i]<<" ";
    }
    cout<<endl;
}
int main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    Read();
    Comps();
    Solve();
    //Check();





    return 0;
}
