#include<bits/stdc++.h>
using namespace std;

int path[300005];
bool b[300005], visited[300005];
vector<int> edge[300005];

void dfs(int s, int p) {
    if(visited[s]) return;
    if(path[s] != -1) path[s] = min(path[s], p);
    else path[s] = p;

    visited[s] = true;
    for(int i : edge[s]) {
        dfs(i, p+1);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin>>n;
    for(int i = 1; i <= n; i++) {
        cin>>b[i];
    }
    cin>>m;
    for(int i = 1; i <= m; i++) {
        int u, v;
        cin>>u>>v;
        edge[u].push_back(v);
        edge[v].push_back(u);
    }

    for(int i = 1; i <= n; i++) {
        path[i] = -1;
    }

    for(int i = 1; i <= n; i++) {
        if(b[i]) dfs(i, 0);
        for(int i = 1; i <= n; i++) visited[i] = false;
    }

    int chet = 0, nechet = 0;
    for(int i = 1; i <= n; i++) {
        if(path[i] % 2 == 0) chet++;
        else nechet++;
    }

    cout<<max(chet, nechet)<<endl;


    return 0;
}
