#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 3e5 + 50;
vector <int> Graph[MAXN];

bool friendsAcceptence[MAXN][3];
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int V, E, MAX = 0;
    cin >> V;
    for (int i = 0; i < V; i++)
    {
        cin >> friendsAcceptence[i][1];
        MAX += friendsAcceptence[i][1];
    }


    cin >> E;
    for (int i = 0; i < E; i++)
    {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        Graph[x].emplace_back(y);
        Graph[y].emplace_back(x);
    }

    bool hasCycle = false;
    int currBr = 0;

    while (!hasCycle)
    {
        for (int i = 0; i < V; i++)
        {
            if (friendsAcceptence[i][1] == true)
            {
                for (int Friend:Graph[i])
                    friendsAcceptence[Friend][2] = true;
            }
        }

        currBr = 0;
        hasCycle = true;
        for (int i = 0; i < V; i++)
        {
            if (friendsAcceptence[i][2] != friendsAcceptence[i][0])
                hasCycle = false;

            //cout << friendsAcceptence[i][2] << " ";

            currBr += friendsAcceptence[i][2];
            friendsAcceptence[i][0] = friendsAcceptence[i][1];
            friendsAcceptence[i][1] = friendsAcceptence[i][2];
            friendsAcceptence[i][2] = false;
        }
        //cout << endl;
        MAX = max(MAX, currBr);
    }

    cout << MAX << endl;


    return 0;
}
/*
7
1 0 0 0 0 0 1
6
1 2
1 3
1 4
4 5
5 6
2 5
*/
