#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 2 * 1e7 + 10;
int n, l, p, f;
int m, r, q, g;
int a[maxn], b[maxn];

void fillVectors(){
    a[0] = l % p;
    b[0] = r % q;
    for(int i = 1;i < n;i++){
        a[i] = (a[i - 1] + l) % p;
    }
    for(int i = 1;i < m;i++){
        b[i] = (b[i - 1] + r) % q;
    }
    for(int i = 0;i < f;i++){
        a[i] = -a[i];
    }
    for(int i = 0;i < g;i++){
        b[i] = -b[i];
    }
    sort(a, a + n);
}

int bin(int s){
    int l = 0, r = n - 1;
    if(s > a[r]) return abs(s - a[r]);
    while(l <= r){
        int mid = (l + r) / 2;
        if(a[mid] >= s) r = mid - 1;
        else l = mid + 1;
    }
    int s1 = abs(s - a[l]), s2 = abs(s - a[r]), s3 = abs(s - a[(l + r) / 2]);
    int p = min(s1, min(s2, s3));
    return p;
}
void solve(){
    set<int> ans;
    vector<int> print;
    for(int i = 0;i < m;i++){
        int s = bin(b[i]);
        if(ans.count(s) == 0){
            print.push_back(s);
            ans.insert(s);
        }
    }
    sort(print.begin(), print.end());
    int sz = print.size();
    cout << print.size() << endl;
    for(int i = sz - 1;i >= 0;i--){
        cout << print[i] << " ";
    }
    cout << endl;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> l >> p >> f;
    cin >> m >> r >> q >> g;
    fillVectors();
    solve();
    return 0;
}
