#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 2 * 1e7 + 10;
int n, l, p, f;
int m, r, q, g;
int a[maxn], b[maxn], cnt1[maxn], cnt2[maxn];

void fillVectors(){
    a[0] = l % p;
    b[0] = r % q;
    cnt1[b[0]] = cnt2[b[0]] = -1;
    for(int i = 1;i < n;i++){
        a[i] = (a[i - 1] + l) % p;
    }
    for(int i = 1;i < m;i++){
        b[i] = (b[i - 1] + r) % q;
        cnt1[b[i]] = cnt2[b[i]] = -1;
    }
    for(int i = 0;i < f;i++){
        a[i] = -a[i];
    }
    for(int i = 0;i < g;i++){
        b[i] = -b[i];
    }
    sort(a, a + n);
}

int bin(int s){
    int l = 0, r = n - 1;
    if(s > a[r]) return abs(s - a[r]);
    while(l <= r){
        int mid = (l + r) / 2;
        if(a[mid] >= s) r = mid - 1;
        else l = mid + 1;
    }
    int s1 = abs(s - a[l]), s2 = abs(s - a[r]), s3 = abs(s - a[(l + r) / 2]);
    int p = min(s1, min(s2, s3));
    return p;
}
void solve(){
    vector<int> print, ans;
    for(int i = 0;i < m;i++){
        if(b[i] < 0){
            if(cnt2[abs(b[i])] == -1){
                int s = bin(b[i]);
                print.push_back(s);
                cnt2[abs(b[i])] = s;
            }
            else{
                print.push_back(cnt2[abs(b[i])]);
            }
        }
        else{
            if(cnt1[b[i]] == -1){
                int s = bin(b[i]);
                print.push_back(s);
                cnt1[b[i]] = s;
            }
            else{
                print.push_back(cnt1[b[i]]);
            }
        }

    }
    sort(print.begin(), print.end());
    int sz = print.size();
    ans.push_back(print[sz - 1]);
    for(int i = sz - 2;i >= 0;i--){
        if(print[i] != print[i + 1]) ans.push_back(print[i]);
    }
    sz = ans.size();
    cout << sz << endl;
    for(int i = 0;i < sz;i++){
        cout << ans[i] << " ";
    }
    cout << endl;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> l >> p >> f;
    cin >> m >> r >> q >> g;
    fillVectors();
    solve();
    return 0;
}
