#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 3 * 1e5 + 10;
int n, m, ans, a[maxn], used[maxn], used2[maxn], b[maxn];
vector<int> v[maxn], topo;

void read(){
    cin >> n;
    for(int i = 0;i < n;i++){
        cin >> a[i];
        ans += a[i];
    }
    cin >> m;
    for(int i = 0;i < m;i++){
        int x, y;
        cin >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
}

void dfs(int beg, int cnt){
    used[beg] = cnt;
    b[cnt]++;
    for(int nb : v[beg]){
        if(!used[nb]) dfs(nb, cnt);
    }
}

void DFS(int beg){
    used2[beg] = 1;
    for(int nb : v[beg]){
        if(!used2[nb]) DFS(nb);
    }
    topo.push_back(beg);
}

void solve(){
    int col = 1;
    for(int i = 1;i <= n;i++){
        if(!used[i]) dfs(i, col++);
    }
    int maxcol = 1;
    for(int i = 1;i <= n;i++){
        if(b[maxcol] < b[i]) maxcol = i;
    }
    int idx = 1;
    while(used[idx] != maxcol) idx++;
    DFS(idx);
    cout << topo.size() << endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
