#include<iostream>
#include<vector>
#include<queue>
using namespace std;
const int MAX_N=3e5+4;

int level[MAX_N];
int cnt1[MAX_N];
int cnt2[MAX_N];
int all1;
int all2;

vector<int>g[MAX_N];
bool ok[MAX_N];
int n,m;

int used[MAX_N];
int cnt;
vector<int>comp[MAX_N];

int b;
void Read()
{
    cin>>n;
    for(int i=1;i<=n;i++)
    {
        cin>>ok[i];
        b+=ok[i];
    }
    cin>>m;
    int u,v;
    for(int i=1;i<=m;i++)
    {
        cin>>u>>v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
}
void DFS(int u)
{
    if(ok[u])comp[cnt].push_back(u);
    used[u]=cnt;
    for(int v:g[u])
    {
        if(!used[v])
        {
            DFS(v);
        }
    }
}
void Comps()
{
    for(int i=1;i<=n;i++)
    {
        if(!used[i])
        {
            cnt++;
            DFS(i);
        }
    }
}
void SolveFor(int cur)
{
    queue<int>q;
    for(int u:comp[cur])
    {
        level[u]=1;
        cnt1[cur]++;
        q.push(u);
    }
    while(!q.empty())
    {
        int u=q.front();
        q.pop();
        for(int v:g[u])
        {
            if(!level[v])
            {
                level[v]=level[u]+1;
                if(level[v]%2==0)cnt2[cur]++;
                else cnt1[cur]++;
                q.push(v);
            }
        }
    }
    all1+=cnt1[cur];
    all2+=cnt2[cur];
}
void Solve()
{
    for(int i=1;i<=cnt;i++)
    {
        SolveFor(i);
    }
    cout<<max(b,max(all1,all2))<<endl;
}
int main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    Read();
    Comps();
    Solve();





    return 0;
}
