#include<bits/stdc++.h>
using namespace std;

int n;
bool b[300005], c[300005], d[300005], visited[300005];
vector<int> edge[300005];

void simulate() {
    for(int i = 1; i <= n; i++) {
        if(b[i]) {
            for(int j : edge[i]) {
                if(visited[j]) continue;

                if(b[j]) c[i] = true;
                c[j] = true;
            }
        }
    }
}

int ans = 0;

void countAns() {
    int cur = 0;
    ans = 0;
    for(int i = 1; i <= n; i++) {
        if(b[i]) cur++;
    }
    ans = max(ans, cur);
}

bool resetAndCheck() {
    int num = 0, cur = 0;
    for(int i = 1; i <= n; i++) {
        if(c[i] == d[i]) num++;
        if(b[i]) cur++;
        d[i] = b[i];
        b[i] = c[i];
        visited[i] = false;
        c[i] = false;
    }
    ans = max(ans, cur);
    if(num == n) return true;
    return false;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int m;
    cin>>n;
    for(int i = 1; i <= n; i++) {
        cin>>b[i];
    }
    cin>>m;
    for(int i = 1; i <= m; i++) {
        int u, v;
        cin>>u>>v;
        edge[u].push_back(v);
        edge[v].push_back(u);
    }


    countAns();
    while(true) {
        simulate();
        bool check = resetAndCheck();
        if(check || ans == n) break;
    }

    cout<<ans<<endl;


    return 0;
}
