#include<bits/stdc++.h>
using namespace std;

const int MAXN=400004;

vector<int> edges[MAXN];
bool used[MAXN], cheten[MAXN], necheten[MAXN];
void bfs(int s){
    queue<int> q;
    q.push(s);
    used[s]=true;
    cheten[s]=true;
    while(!q.empty()){
        int u=q.front();
        q.pop();
        for(auto v: edges[u]){
            if(!used[v]) q.push(v);
            used[v]=true;
            if(necheten[u] && !cheten[v]){
                if(used[v]) q.push(v);
                cheten[v]=true;
            }
            if(cheten[u] && !necheten[v]){
                if(used[v]) q.push(v);
                necheten[v]=true;
            }
        }
    }
}
void clear_(){
    for(int i=0;i<MAXN;i++) used[i]=false;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    vector<int> nachalo;
    int n, m;
    cin>>n;
    for(int i=1;i<=n;i++){
        int buff;
        cin>>buff;
        if(buff==1) nachalo.push_back(i);
    }
    cin>>m;
    for(int i=0;i<m;i++){
        int x, y;
        cin>>x>>y;
        edges[x].push_back(y);
        edges[y].push_back(x);
    }
    for(int i=0;i<nachalo.size();i++){
        if(!edges[nachalo[i]].empty()) bfs(nachalo[i]);
        clear_();
    }
    int nech=0, ch=0;
    for(int i=1;i<=n;i++){
        if(necheten[i]) nech++;
        if(cheten[i]) ch++;
    }
    cout<<max(ch, nech);
    return 0;
}
