#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
const int MAXN = 2*1e7+10;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int n, l, p, f;
int m, r, q, g;
int a[MAXN], b[MAXN];

void read()
{
    cin >> n >> l >> p >> f;
    cin >> m >> r >> q >> g;
}

void gen_arrays()
{
    int cnt = 1;
    a[1] = l % p;
    if(cnt <= f)
        a[1] = -a[1];
    for (int i = 2; i <= n; ++ i)
    {
        cnt ++;
        a[i] = (abs(a[i-1]) + l)%p;
        if(cnt <= f)
            a[i] = -a[i];
    }
    /**********************************************/
    cnt = 1;
    b[1] = r % q;
    if(cnt <= g)
        b[1] = -b[1];
    for (int i = 2; i <= m; ++ i)
    {
        cnt ++;
        b[i] = (abs(b[i-1]) + r)%q;
        if(cnt <= g)
            b[i] = -b[i];
    }
}

void print_arrays()
{
    for (int i = 1; i <= n; ++ i)
        cout << a[i] << " ";
    cout << endl;
    for (int i = 1; i <= m; ++ i)
        cout << b[i] << " ";
    cout << endl;
}
/****************************************************************************************************************************************************************************************************************************/
unordered_map < int, int > mp;
void solve()
{
    long long ans = 0, cnt = 0;
    int i = 1, j = 1;

    vector < int > diff;
    while(j <= m)
    {
        while(i < n && a[i+1] < b[j])
            i ++;
        int op1 = a[i], op2 = a[i+1];
        if(i == n)
            op2 = 1e9;
        ans = min(abs(op1 - b[j]), abs(op2 - b[j]));
        if(mp[ans] == 0)
        {
            cnt ++;
            diff.push_back(ans);
            mp[ans] = 1;
        }
        j ++;
    }

    cout << cnt << endl;
    sort(diff.begin(), diff.end());
    for (int i = diff.size()-1; i >= 0; -- i)
        cout << diff[i] << " ";
    cout << endl;
}

/****************************************************************************************************************************************************************************************************************************/

unordered_map < int, int > mpA, mpB;
vector < int > aa, bb;
void solve14()
{
    vector < int > diffA;
    for (int i = 1; i <= n; ++ i)
    {
        mpA[a[i]] ++;
        if(mpA[a[i]] == 1)
        {
            diffA.push_back(a[i]);
            aa.push_back(a[i]);
        }
    }
    vector < int > diffB;
    for (int i = 1; i <= m; ++ i)
    {
        mpB[b[i]] ++;
        if(mpB[b[i]] == 1)
        {
            diffB.push_back(b[i]);
            bb.push_back(b[i]);
        }
    }

    sort(aa.begin(), aa.end());
    sort(bb.begin(), bb.end());

    long long ans = 0, cnt = 0;
    int i = 1, j = 1;

    vector < int > diff;
    while(j < bb.size())
    {
        while(i < aa.size()-1 && aa[i+1] < bb[j])
            i ++;
        int op1 = aa[i], op2 = aa[i+1];
        if(i == aa.size()-1)
            op2 = 1e9;
        ans = min(abs(op1 - bb[j]), abs(op2 - bb[j]));
        if(mp[ans] == 0)
        {
            cnt ++;
            diff.push_back(ans);
            mp[ans] = 1;
        }
        j ++;
    }

    cout << cnt << endl;
    sort(diff.begin(), diff.end());
    for (int i = diff.size()-1; i >= 0; -- i)
        cout << diff[i] << " ";
    cout << endl;
}

/****************************************************************************************************************************************************************************************************************************/

void solve15()
{
    sort(a+1, a+n+1);
    //print_arrays();
    vector < int > diff;
    int cnt = 0;
    int prevmid = 1;
    for (int i = 1; i <= m; ++ i)
    {
        int left = prevmid, right = n, mid = 1, ans = n;
        //cout << "searching for smaller " << b[i] << endl;
        while(left <= right)
        {
            mid = (left + right)/2;
            if(a[mid] >= b[i])
            {
                //cout << a[mid] << endl;
                ans = min(ans, mid);
                right = mid - 1;
            }
            else left = mid + 1;
        }
        int differ = abs(a[ans] - b[i]);
        //cout << b[i] << "  " << a[ans] << endl;
        if(mid != 1)differ = min(differ, abs(a[ans-1] - b[i]));
        if(mp[differ] == 0)
        {
            cnt ++;
            diff.push_back(differ);
            mp[differ] = 1;
        }
        prevmid = ans;
    }
    cout << cnt << endl;
    sort(diff.begin(), diff.end());
    for (int i = diff.size()-1; i >= 0; -- i)
        cout << diff[i] << " ";
    cout << endl;
}
int main()
{

    speed();

    read();
    gen_arrays();
    //print_arrays();
    if(n <= 1e6 && m <= 1e6)
    {
        sort(a+1, a+n+1);
        sort(b+1, b+m+1);
        solve();
        return 0;
    }
    if(p <= 1e4 && q <= 1e4 && f == 0 && g == 0)
    {
        solve14();
        return 0;
    }
    solve15();
    return 0;
}
/***
10 21 17 4
5 3 15 2

*/
