#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

int n, l, p, f;
int m, r, q, g;
vector<long long> a, b;

void fillVectors(){
    a.push_back(l % p);
    b.push_back(r % q);
    for(int i = 1;i < n;i++){
        a.push_back((a[i - 1] + l) % p);
    }
    for(int i = 1;i < m;i++){
        b.push_back((b[i - 1] + r) % q);
    }
    for(int i = 0;i < f;i++){
        a[i] = -a[i];
    }
    for(int i = 0;i < g;i++){
        b[i] = -b[i];
    }
    sort(a.begin(), a.end());
}

long long bin(long long s){
    int l = 0, r = n - 1;
    while(l <= r){
        int mid = (l + r) / 2;
        if(a[mid] >= s) r = mid - 1;
        else l = mid + 1;
    }
    long long s1 = abs(s - a[l]), s2 = abs(s - a[r]), s3 = abs(s - a[(l + r) / 2]);
    long long p = min(s1, min(s2, s3));
    return p;
}
void solve(){
    set<long long> ans;
    for(int i = 0;i < m;i++){
        long long s = bin(b[i]);
        ans.insert(s);
    }
    cout << ans.size() << endl;
    for(auto it = ans.rbegin();it != ans.rend();it++){
        cout << *it << " ";
    }
    cout << endl;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> l >> p >> f;
    cin >> m >> r >> q >> g;
    fillVectors();
    solve();
    return 0;
}