#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 2 * 1e7 + 10;
const int maxm = 4 * 1e6 + 10;
int n, l, p, f;
int m, r, q, g;
int a[maxn], b[maxn], cnt1[maxm], cnt2[maxm], cnt[maxm];

void fillVectors(){
    a[0] = l % p;
    b[0] = r % q;
    for(int i = 1;i < n;i++){
        a[i] = (a[i - 1] + l) % p;
    }
    for(int i = 1;i < m;i++){
        b[i] = (b[i - 1] + r) % q;
    }
    for(int i = 0;i < f;i++){
        a[i] = -a[i];
    }
    for(int i = 0;i < n;i++){
        if(a[i] < 0){
            cnt1[abs(a[i])]++;
        }
        else{
            cnt2[a[i]]++;
        }
    }
    int pos = 0;
    for(int i = 0;i < maxm;i++){
        if(cnt1[i]) a[pos++] = -i;
        if(cnt2[i]) a[pos++] = i;
    }
    n = pos;
    for(int i = 0;i < g;i++){
        b[i] = -b[i];
    }
    sort(a, a + n);
    memset(cnt1, -1, sizeof(cnt1));
    memset(cnt2, -1, sizeof(cnt2));
}

int bin(int s){
    int l = 0, r = n - 1;
    if(s > a[r]) return abs(s - a[r]);
    while(l <= r){
        int mid = (l + r) / 2;
        if(a[mid] >= s) r = mid - 1;
        else l = mid + 1;
    }
    int s1 = abs(s - a[l]), s2 = abs(s - a[r]), s3 = abs(s - a[(l + r) / 2]);
    int p = min(s1, min(s2, s3));
    return p;
}
void solve(){
    int ans = 0;
    for(int i = 0;i < m;i++){
        if(b[i] < 0){
            if(cnt2[abs(b[i])] == -1){
                int s = bin(b[i]);
                if(cnt[s] == 0) cnt[s]++, ans++;
                cnt2[abs(b[i])] = s;
            }
        }
        else{
            if(cnt1[b[i]] == -1){
                int s = bin(b[i]);
                if(cnt[s] == 0) cnt[s]++, ans++;
                cnt1[b[i]] = s;
            }
        }

    }
    cout << ans << endl;
    for(int i = maxm - 1;i >= 0;i--){
        if(cnt[i]) cout << i << " ";
    }
    cout << endl;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> l >> p >> f;
    cin >> m >> r >> q >> g;
    fillVectors();
    solve();
    return 0;
}
